﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using RowDetails;
using RowDetails.Grid;
using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using Syncfusion.XlsIO;
using System.Web.Script.Serialization;
using System.Collections;
using System.Reflection;

namespace RowDetails.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public ActionResult GridFeatures()
        {
            var DataSource = GetData();
            ViewBag.datasource = DataSource;
            return View();
        }

        private List<Person>  GetData()
        {
            List<Person> Persons = new List<Person>();
            Persons.Add(new Person() { ID = 1,  FirstName = "John", LastName = "Beckett", Email = "john@syncfusion.com" });
            Persons.Add(new Person() { ID = 2, FirstName = "Ben", LastName = "Beckett", Email = "ben@syncfusion.com" });
            Persons.Add(new Person() { ID = 3, FirstName = "Andrew", LastName = "Beckett", Email = "andrew@syncfusion.com" });
            return Persons;
        }

        public void ExportToExcel(string GridModel)
        {
            ExcelExport exp = new ExcelExport();
            var DataSource = GetData();
            GridProperties obj = ConvertGridObject(GridModel);
            exp.Export(obj, DataSource, "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-saffron");
        }

        private List<Details> GetDetails()
        {
            List<Details> Details = new List<Details>();
            Details.Add(new Details() { ID = 1, IdPerson = 1,  Order = "Bikes", Count=10 });
            Details.Add(new Details() { ID = 2, IdPerson = 1, Order = "Drones", Count = 17 });
            Details.Add(new Details() { ID = 3, IdPerson = 1, Order = "Cars", Count = 23 });
            Details.Add(new Details() { ID = 4, IdPerson = 1, Order = "Motos", Count = 4 });
            Details.Add(new Details() { ID = 5, IdPerson = 2, Order = "u-boats", Count = 7 });
            Details.Add(new Details() { ID = 6, IdPerson = 2, Order = "Ships", Count = 8 });
            Details.Add(new Details() { ID = 7, IdPerson = 2, Order = "Airplane", Count = 43 });
            Details.Add(new Details() { ID = 8, IdPerson = 2, Order = "Helicopter", Count = 3 });
            Details.Add(new Details() { ID = 9, IdPerson = 2, Order = "Sidecar", Count = 5 });
            Details.Add(new Details() { ID = 10, IdPerson = 3, Order = "Delta wing", Count = 11 });
            Details.Add(new Details() { ID = 11, IdPerson = 4, Order = "Surf Board", Count = 32 });
            

            return Details;
        }

        public JsonResult GetDetailsUser(int user)
        {
            var result = GetDetails().Where(x => x.IdPerson == user).ToList();
            return Json(result);
        }

        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }
    }

    internal class Person
    {
        public int ID { get; set; }

        public string FirstName { get; set; }

        public string LastName { get; set; }

        public string Email { get; set; }
    }

    internal class Details
    {
        public int ID { get; set; }

        public int IdPerson { get; set; }

        public string Order { get; set; }

        public int Count { get; set; }
    }

}
